> For the complete documentation index, see [llms.txt](https://docs.rei.network/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.rei.network/developer/system-contracts/feepool.md).

# FeePool

## Contents

## Globals

| Var             | Type                        |
| --------------- | --------------------------- |
| sharesOf        | mapping(address => uint256) |
| totalShares     | uint256                     |
| accTxFee        | uint256                     |
| globalTimestamp | uint256                     |
| validators      | address\[]                  |

## Functions

### constructor

No description

**Declaration:**

```solidity
  function constructor(
  ) public Only
```

**Modifiers:**

| Modifier |
| -------- |
| Only     |

### validatorsLength

Get validators length.

**Declaration:**

```solidity
  function validatorsLength(
  ) external returns (uint256)
```

**Modifiers:** No modifiers

### earn

Increase miner's share.

**Declaration:**

```solidity
  function earn(
    address validator,
    uint256 earned
  ) external nonReentrant onlyRouter
```

**Modifiers:**

| Modifier     |
| ------------ |
| nonReentrant |
| onlyRouter   |

**Args:**

| Arg         | Type    | Description         |
| ----------- | ------- | ------------------- |
| `validator` | address | Miner address       |
| `earned`    | uint256 | Miner earned share. |

### accumulate

Add reward to fee pool.

**Declaration:**

```solidity
  function accumulate(
    bool isTxFee
  ) external nonReentrant onlyRouter
```

**Modifiers:**

| Modifier     |
| ------------ |
| nonReentrant |
| onlyRouter   |

**Args:**

| Arg       | Type | Description        |
| --------- | ---- | ------------------ |
| `isTxFee` | bool | Is transaction fee |

### onAssignBlockReward

Assign block reward callback, it only can be called by router.

**Declaration:**

```solidity
  function onAssignBlockReward(
  ) external nonReentrant onlyRouter
```

**Modifiers:**

| Modifier     |
| ------------ |
| nonReentrant |
| onlyRouter   |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.rei.network/developer/system-contracts/feepool.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
